=== debian/changelog ===
julia (1.0.3+dfsg-4) unstable; urgency=medium

  [ Mo Zhou ]
  * Set JULIA_CPU_TARGET="pwr8" for ppc64el architecture

  [ Graham Inggs]
  * Avoid baseline violation on armhf, thanks Adrian Bunk
    (Closes: #919183)
  * Build with GCC 8 on armhf again

 -- Graham Inggs <ginggs@debian.org>  Tue, 22 Jan 2019 20:19:55 +0000

julia (1.0.3+dfsg-3) unstable; urgency=medium

  * Switch to use embedded LLVM-6.0.0 with upstream patches.
    + Embed llvm-6.0.0.src.tar.xz to debian/embedded.
    + Register new tarball in source/include-binaries.
    + Set USE_SYSTEM_LLVM=0 in rules.
    + Add patch do-not-download-llvm.patch to redirect downloading.
    + Add symlinks in debian/embedded to avoid "download" errors.
    + Add cmake, python3 to B-D for the embedded LLVM.
    + Update copyright for the embedded LLVM.
    + Patch Makefile and update rules to amend installation.
    + Install the embedded LLVM to Julia's private library directory.
    + dh_makeshlibs: Don't track symbols for the private LLVM library.
    - Drop B-D on Debian's LLVM 6.0
    - Remove makefile options for system LLVM.
  * Remove the DESTDIR definition from make flags. This definition
    screws up installtion of embedded LLVM.
  * Add hack for embedded LLVM to let it install shlibs correctly.
  * Refresh patches (quilt push -a --refresh).
  * Skip more DNS tests for Sockets.jl module.

 -- Mo Zhou <cdluminate@gmail.com>  Thu, 17 Jan 2019 15:27:52 +0000

julia (1.0.3+dfsg-2) unstable; urgency=medium

  [ Graham Inggs ]
  * Skip DNS tests which fail on Ubuntu autopkgtest infrastructure

  [ Mo Zhou ]
  * Add d/gitlab-ci.yml for enabling Salsa CI pipeline.
  * Delete the unused DEBIAN_FORCE_NONET env var from rules and autopkgtest.
  * Update copyright for embedded .jl packages.
  * Uscan: add dversionmangle option to append +dfsg postfix.
  * Add headers for headless patches.
  * Add patch (disabled by default) to append "@distro" to default LOAD_PATH.
  * Bump Standards-Version to 4.3.0 (no change).
  * Rollback embedded Documenter to 0.20.0, DocStringExtensions to 0.5.0 .
  * Refresh the list of included-binaries.
  * Bump B-D-I pygmentize to Py3 version.
    + Append python3-pkg-resources to B-D-I to workaround #918401
  * Add repacksuffix option to uscan.
  * Add openssl to B-D (more test coverage) and Recommends.

 -- Mo Zhou <cdluminate@gmail.com>  Sun, 13 Jan 2019 10:53:28 +0000

julia (1.0.3+dfsg-1) unstable; urgency=medium

  * Users who want to use MKL as Julia's BLAS/LAPACK backend should
    rebuild this package after turning on the CUSTOM_MKL flag in d/rules.
    I temporarily reverted the use of alternatives mechanism because the
    code of stdlib/LinearAlgebra is not ready for such a feature.

  * DFSG: Exclude contrib/windows/7zS.sfx (Closes: #916957)
  * Remove the aforementioned incremental patch since the
    source tarball has been refreshed.
  * Revert "Link libjulia.so.X against libblas.so.3 to take
    advantage from alternatives." (Closes: #916991)

 -- Mo Zhou <cdluminate@gmail.com>  Fri, 21 Dec 2018 14:47:47 +0000

julia (1.0.3-2) unstable; urgency=medium

  * Cherry-pick incremental patch from upstream's force-pushed 1.0.3 tag.

 -- Mo Zhou <cdluminate@gmail.com>  Tue, 18 Dec 2018 06:25:16 +0000

julia (1.0.3-1) unstable; urgency=medium

  * New upstream version 1.0.3
  * Strip shared object libjulia.so.1 , whilst sys.so is still unstripped.
  * Update embedded tarball for Pkg.jl .
  * Refresh and update patches, including patches for embedded source.
    * Refresh doc-silent.patch on new embedded source.
  * Upgrade embedded DocStringExtensions.jl to v0.6.0
  * Upgrade embedded Documenter to v0.21.0
  * Remove embedded Compat.jl, not used by Documenter.jl anymore.

 -- Mo Zhou <cdluminate@gmail.com>  Mon, 17 Dec 2018 10:15:03 +0000

julia (1.0.2-1) unstable; urgency=medium

  * New upstream version 1.0.2
  * Remove test-precision.patch, merged upstream.
  * Import Pkg.jl tarball to d/embedded directory.
    Its sha512sum matches with the one provided by upstream.
    + Register the Pkg.jl tarball in include-binaries.
    + Patch makefile to avoid downloading Pkg.jl tarball.
  * Remove LLVM_DISABLE_ABI_BREAKING_CHECKS_ENFORCING definition from rules.
  * Refresh Patches.

 -- Mo Zhou <cdluminate@gmail.com>  Thu, 29 Nov 2018 06:50:23 +0000

julia (1.0.1-2) unstable; urgency=medium

  * Extend JULIA_CPU_TARGET to include optimized targets as well,
    apart from the generic target. (Closes: #910784)

 -- Mo Zhou <cdluminate@gmail.com>  Sat, 13 Oct 2018 06:16:18 +0000

julia (1.0.1-1) unstable; urgency=medium

  * New upstream stable release 1.0.1 (Sept 2018)
  * Remove hundreds of patches picked from WIP Julia 1.0.1 release.
  * Elaborate on why debug info should not be stripped from sys.so in rules.
  * Drop deps:openspecfun which is not used anymore since 0.7 release.
  * Add CUSTOM_NATIVE variable in rules for custom builds.
  * Drop test related patches, because they are not needed anymore:
    - Drop test-add-envvar-for-skipping-network-tests.patch .
    - Drop test-moredetail.patch, test-skip-ppc64el-spec.patch
    - Drop test-remove-powermod.patch, test-aggressive-gc.patch .

 -- Mo Zhou <cdluminate@gmail.com>  Sun, 30 Sep 2018 15:22:20 +0000
